/*
	Проект: LITE-AMX
	Группа проекта: https://vk.com/lite_amx
*/

#include amxmodx
#include reapi
#include hamsandwich
#include zombieplague

new const ARMOR_MODEL[] = "models/v_armorplate.mdl";

new const ITEM_NAME[] = "Броня"; 		// Название в магазине
new const ITEM_COST = 20; 				// Цена
new const Float: ARMOR_VALUE = 150.0; 	// Будет выдано брони
new const Float: ARMOR_LIMIT = 300.0; 	// Лимит брони

new bool: gl_bUserCanDeploy[MAX_PLAYERS + 1];
new gl_iItemID;

public plugin_init()
{
	register_plugin("[ReAPI & ZP] Armor Plate", "1.1", "gajerek");
	
	RegisterHookChain(RG_CBasePlayerWeapon_CanDeploy, "@CBasePlayerWeapon__CanDeploy_Pre", .post = false);
	
	gl_iItemID = zp_register_extra_item(ITEM_NAME, ITEM_COST, ZP_TEAM_HUMAN);
}

public plugin_precache()
	precache_model(ARMOR_MODEL);

public zp_extra_item_selected(iPlayer, iItemID)
{
	if(iItemID == gl_iItemID)
	{
		if(get_entvar(iPlayer, var_armorvalue) >= ARMOR_LIMIT)
			return ZP_PLUGIN_HANDLED;
		@Command_ArmorPlate(iPlayer);
	}
	return PLUGIN_HANDLED;
}

public client_putinserver(iPlayer)
	gl_bUserCanDeploy[iPlayer] = true;

@Command_ArmorPlate(iPlayer)
{
	if(!is_user_connected(iPlayer))
		return;
	
	set_entvar(iPlayer, var_viewmodel, ARMOR_MODEL);
	set_member(iPlayer, m_flNextAttack, 1.491666666666667);
	gl_bUserCanDeploy[iPlayer] = false;
	
	set_task(1.291666666666667, "@Task__AddArrmorToPlayer", iPlayer + 3323929);
}

@Task__AddArrmorToPlayer(TaskID)
{
	static iPlayer; iPlayer = TaskID - 3323929;
	if(!zp_get_user_zombie(iPlayer))
	{
		new Float: flArmor = get_entvar(iPlayer, var_armorvalue);
		set_entvar(iPlayer, var_armorvalue, flArmor + ARMOR_VALUE);
		rh_emit_sound2(iPlayer, 0, CHAN_BODY, "items/tr_kevlar.wav");
	}
	gl_bUserCanDeploy[iPlayer] = true;
	
	new iItem = get_member(iPlayer, m_pActiveItem);
	if(is_entity(iItem)) ExecuteHamB(Ham_Item_Deploy, iItem);
	
	remove_task(TaskID);
}

@CBasePlayerWeapon__CanDeploy_Pre(iItem)
{
	static iPlayer;
	if(!(iPlayer = get_member(iItem, m_pPlayer)) || !is_user_connected(iPlayer))
		return HC_CONTINUE;
	if(!gl_bUserCanDeploy[iPlayer])
	{
		SetHookChainReturn(ATYPE_INTEGER, false);
		return HC_SUPERCEDE;
	}
	return HC_CONTINUE;
}